diff --git a/yum/yumRepo.py b/yum/yumRepo.py
index e5e9ece..4d64dff 100644
--- a/yum/yumRepo.py
+++ b/yum/yumRepo.py
@@ -1034,8 +1253,9 @@ class YumRepository(Repository, config.RepoConf):
             misc.unlink_f(tfname)
             if grab_can_fail:
                 return None
-            raise Errors.RepoError, 'Error renaming file %s to %s' % (result,
-                                                                      local)
+            raise Errors.RepoError('Error renaming file %s to %s' % (result,
+                                                                      local),
+                                   repo=self)
         return local
 
     def _parseRepoXML(self, local, parse_can_fail=None):
@@ -1047,7 +1267,8 @@ class YumRepository(Repository, config.RepoConf):
                 parse_can_fail = 'old_repo_XML' in self._oldRepoMDData
             if parse_can_fail:
                 return None
-            raise Errors.RepoError, 'Error importing repomd.xml from %s: %s' % (self, e)
+            raise Errors.RepoError('Error importing repomd.xml from %s: %s' % (self.ui_id, e),
+                                   repo=self)
 
     def _saveOldRepoXML(self, local):
         """ If we have an older repomd.xml file available, save it out. """
@@ -1074,7 +1295,8 @@ class YumRepository(Repository, config.RepoConf):
         #  We still want the old data, so we don't download twice. So we
         # pretend everything is good until the revert.
         if not self.timestamp_check:
-            raise Errors.RepoError, "Can't download or revert repomd.xml"
+            raise Errors.RepoError("Can't download or revert repomd.xml for %s" % self.ui_id,
+                                   repo=self)
 
         if 'old_repo_XML' not in self._oldRepoMDData:
             self._oldRepoMDData = {}
@@ -1250,7 +1472,6 @@ class YumRepository(Repository, config.RepoConf):
             self._revertOldRepoXML()
             return False
 
-        self._using_old_MD = caching
         if caching:
             return False # Skip any work.
 
@@ -1260,6 +1481,9 @@ class YumRepository(Repository, config.RepoConf):
         return True
 
     def _check_db_version(self, mdtype, repoXML=None):
+        if self.mddownloadpolicy == 'xml':
+            return False
+
         if repoXML is None:
             repoXML = self.repoXML
         if mdtype in repoXML.repoData:
@@ -1277,11 +1501,11 @@ class YumRepository(Repository, config.RepoConf):
             return None
 
         if not file_check:
-            compressed = dbmdtype.endswith("_db")
-            local = self._get_mdtype_fname(data, compressed)
+            compressed = False
+            local = self._get_mdtype_fname(data)
         else:
             compressed = False
-            local = self._get_mdtype_fname(data, False)
+            local = self._get_mdtype_fname(data)
             if not os.path.exists(local):
                 local = misc.decompress(local, fn_only=True)
                 compressed = True
@@ -1302,6 +1526,17 @@ class YumRepository(Repository, config.RepoConf):
             into the delete list, this means metadata can change filename
             without us leaking it. """
 
+        downloading = self._commonRetrieveDataMD_list(mdtypes)
+        for (ndata, nmdtype) in downloading:
+            if not self._retrieveMD(nmdtype, retrieve_can_fail=True):
+                self._revertOldRepoXML()
+                return False
+        self._commonRetrieveDataMD_done(downloading)
+        return True
+
+    def _commonRetrieveDataMD_list(self, mdtypes):
+        """ Return a list of metadata to be retrieved """
+
         def _mdtype_eq(omdtype, odata, nmdtype, ndata):
             """ Check if two returns from _get_mdtype_data() are equal. """
             if ndata is None:
@@ -1321,6 +1556,14 @@ class YumRepository(Repository, config.RepoConf):
             return True
 
         all_mdtypes = self.retrieved.keys()
+        # Add in any extra stuff we don't know about.
+        for mdtype in self.repoXML.fileTypes():
+            if mdtype in all_mdtypes:
+                continue
+            if mdtype in ('primary_db', 'filelists_db', 'other_db', 'group_gz'):
+                continue
+            all_mdtypes.append(mdtype)
+
         if mdtypes is None:
             mdtypes = all_mdtypes
 
@@ -1332,9 +1575,8 @@ class YumRepository(Repository, config.RepoConf):
             self._oldRepoMDData['old_MD_files'] = reverts
 
         # Inited twice atm. ... sue me
-        self._oldRepoMDData['new_MD_files'] = []
-        downloading_with_size = []
-        downloading_no_size   = []
+        newmdfiles = self._oldRepoMDData['new_MD_files'] = []
+        downloading = []
         for mdtype in all_mdtypes:
             (nmdtype, ndata) = self._get_mdtype_data(mdtype)
 
@@ -1371,43 +1613,16 @@ class YumRepository(Repository, config.RepoConf):
             # No old repomd data, but we might still have uncompressed MD
             if self._groupCheckDataMDValid(ndata, nmdtype, mdtype):
                 continue
+            downloading.append((ndata, nmdtype))
+            newmdfiles.append(self._get_mdtype_fname(ndata, False))
+        return downloading
 
-            if ndata.size is None:
-                downloading_no_size.append((ndata, nmdtype))
-            else:
-                downloading_with_size.append((ndata, nmdtype))
-
-        if len(downloading_with_size) == 1:
-            downloading_no_size.extend(downloading_with_size)
-            downloading_with_size = []
-
-        remote_size = 0
-        local_size  = 0
-        for (ndata, nmdtype) in downloading_with_size: # Get total size...
-            remote_size += int(ndata.size)
+    def _commonRetrieveDataMD_done(self, downloading):
+        """ Uncompress the downloaded metadata """
 
-        for (ndata, nmdtype) in downloading_with_size:
-            urlgrabber.progress.text_meter_total_size(remote_size, local_size)
-            if not self._retrieveMD(nmdtype, retrieve_can_fail=True):
-                self._revertOldRepoXML()
-                return False
-            local_size += int(ndata.size)
-        urlgrabber.progress.text_meter_total_size(0)
-        for (ndata, nmdtype) in downloading_no_size:
-            if not self._retrieveMD(nmdtype, retrieve_can_fail=True):
-                self._revertOldRepoXML()
-                return False
-
-        for (ndata, nmdtype) in downloading_with_size + downloading_no_size:
+        for (ndata, nmdtype) in downloading:
             local = self._get_mdtype_fname(ndata, False)
-            if nmdtype.endswith("_db"): # Uncompress any compressed files
-                dl_local = local
-                local = misc.decompress(dl_local)
-                misc.unlink_f(dl_local)
-            self._oldRepoMDData['new_MD_files'].append(local)
-
         self._doneOldRepoXML()
-        return True
 
     def _groupLoadRepoXML(self, text=None, mdtypes=None):
         """ Retrieve the new repomd.xml from the repository, then check it
@@ -1421,11 +1636,11 @@ class YumRepository(Repository, config.RepoConf):
             self._commonRetrieveDataMD(mdtypes)
 
     def _mdpolicy2mdtypes(self):
-        md_groups = {'instant'       : [],
+        md_groups = {'instant'       : ['__None__'],
                      'group:primary' : ['primary'],
-                     'group:small'   : ["primary", "updateinfo"],
-                     'group:main'    : ["primary", "group", "filelists",
-                                        "updateinfo", "prestodelta"]}
+                     'group:small'   : ["primary", "updateinfo", "group", "pkgtags"],
+                     'group:main'    : ["primary", "updateinfo", "group", "pkgtags",
+                                        "filelists", "prestodelta"]}
         mdtypes = set()
         if type(self.mdpolicy) in types.StringTypes:
             mdtypes.update(md_groups.get(self.mdpolicy, [self.mdpolicy]))
@@ -1436,6 +1651,7 @@ class YumRepository(Repository, config.RepoConf):
         if not mdtypes or 'group:all' in mdtypes:
             mdtypes = None
         else:
+            mdtypes.discard("__None__")
             mdtypes = sorted(list(mdtypes))
         return mdtypes
 
@@ -1446,17 +1662,13 @@ class YumRepository(Repository, config.RepoConf):
         except KeyboardInterrupt:
             self._revertOldRepoXML() # Undo metadata cookie?
             raise
-        raise Errors.RepoError, 'Bad loadRepoXML policy: %s' % (self.mdpolicy)
+        raise Errors.RepoError('Bad loadRepoXML policy (for %s): %s' % (self.ui_id, self.mdpolicy),
+                               repo=self)
 
     def _getRepoXML(self):
         if self._repoXML:
             return self._repoXML
-        try:
-            self._loadRepoXML(text=self)
-        except Errors.RepoError, e:
-            msg = ("Cannot retrieve repository metadata (repomd.xml) for repository: %s. "
-                  "Please verify its path and try again" % self )
-            raise Errors.RepoError, msg
+        self._loadRepoXML(text=self.ui_id)
         return self._repoXML
 
 
@@ -1480,7 +1692,7 @@ class YumRepository(Repository, config.RepoConf):
                 result = self._getFile(relative='repodata/repomd.xml.asc',
                                        copy_local=1,
                                        local = sigfile,
-                                       text='%s/signature' % self.id,
+                                       text='%s/signature' % self.ui_id,
                                        reget=None,
                                        checkfunc=None,
                                        cache=self.http_caching == 'all',
@@ -1508,6 +1720,18 @@ class YumRepository(Repository, config.RepoConf):
             raise URLGrabError(-1, 'repomd.xml does not match metalink for %s' %
                                self)
 
+    def _del_dl_file(self, local, size):
+        """ Delete a downloaded file if it's the correct size. """
+
+        sd = misc.stat_f(local)
+        if not sd: # File doesn't exist...
+            return
+
+        if size and sd.st_size < size:
+            return # Still more to get...
+
+        # Is the correct size, or too big ... delete it so we'll try again.
+        misc.unlink_f(local)
 
     def checkMD(self, fn, mdtype, openchecksum=False):
         """check the metadata type against its checksum"""
@@ -1537,6 +1761,16 @@ class YumRepository(Repository, config.RepoConf):
         if size is not None:
             size = int(size)
 
+        l_csum = _xattr_get_chksum(file, r_ctype)
+        if l_csum:
+            fsize = misc.stat_f(file)
+            if fsize is not None: # We just got an xattr, so it should be there
+                if size is None and l_csum == r_csum and fsize.st_size > 0:
+                    return 1
+                if size == fsize.st_size and l_csum == r_csum:
+                    return 1
+            # Anything goes wrong, run the checksums as normal...
+
         try: # get the local checksum
             l_csum = self._checksum(r_ctype, file, datasize=size)
         except Errors.RepoError, e:
@@ -1545,21 +1779,20 @@ class YumRepository(Repository, config.RepoConf):
             raise URLGrabError(-3, 'Error performing checksum')
 
         if l_csum == r_csum:
+            _xattr_set_chksum(file, r_ctype, l_csum)
             return 1
         else:
             if check_can_fail:
                 return None
             raise URLGrabError(-1, 'Metadata file does not match checksum')
 
-
-
     def retrieveMD(self, mdtype):
         """base function to retrieve metadata files from the remote url
            returns the path to the local metadata file of a 'mdtype'
            mdtype can be 'primary', 'filelists', 'other' or 'group'."""
         return self._retrieveMD(mdtype)
 
-    def _retrieveMD(self, mdtype, retrieve_can_fail=False):
+    def _retrieveMD(self, mdtype, retrieve_can_fail=False, **kwargs):
         """ Internal function, use .retrieveMD() from outside yum. """
         #  Note that this can raise Errors.RepoMDError if mdtype doesn't exist
         # for this repo.
@@ -1575,37 +1808,38 @@ class YumRepository(Repository, config.RepoConf):
             # got it, move along
             return local
 
-        if self.cache == 1:
-            if os.path.exists(local):
-                try:
-                    self.checkMD(local, mdtype)
-                except URLGrabError, e:
-                    raise Errors.RepoError, \
-                        "Caching enabled and local cache: %s does not match checksum" % local
-                else:
-                    return local
-
-            else: # ain't there - raise
-                raise Errors.RepoError, \
-                    "Caching enabled but no local cache of %s from %s" % (local,
-                           self)
-
         if (os.path.exists(local) or
             self._preload_md_from_system_cache(os.path.basename(local))):
             if self._checkMD(local, mdtype, check_can_fail=True):
                 self.retrieved[mdtype] = 1
                 return local # it's the same return the local one
 
+        if self.cache == 1:
+            if retrieve_can_fail:
+                return None
+            if os.path.exists(local):
+                msg = "Caching enabled and local cache: %s does not match checksum" % local
+            else:
+                msg = "Caching enabled but no local cache of %s from %s" % (local, self.ui_id)
+            raise Errors.RepoError(msg, repo=self)
+
         try:
-            checkfunc = (self.checkMD, (mdtype,), {})
-            text = "%s/%s" % (self.id, mdtype)
+            def checkfunc(obj):
+                try:
+                    self.checkMD(obj, mdtype)
+                except URLGrabError:
+                    #  Don't share MD among mirrors, in theory we could use:
+                    #     self._del_dl_file(local, int(thisdata.size))
+                    # ...but this is safer.
+                    misc.unlink_f(obj.filename)
+                    raise
+                self.retrieved[mdtype] = 1
+            text = "%s/%s" % (self.ui_id, mdtype)
             if thisdata.size is None:
                 reget = None
             else:
                 reget = 'simple'
-                if os.path.exists(local):
-                    if os.stat(local).st_size >= int(thisdata.size):
-                        misc.unlink_f(local)
+                self._del_dl_file(local, int(thisdata.size))
             local = self._getFile(relative=remote,
                                   local=local, 
                                   copy_local=1,
@@ -1613,18 +1847,18 @@ class YumRepository(Repository, config.RepoConf):
                                   checkfunc=checkfunc, 
                                   text=text,
                                   cache=self.http_caching == 'all',
-                                  size=thisdata.size)
-        except (Errors.NoMoreMirrorsRepoError, Errors.RepoError):
+                                  size=thisdata.size,
+                                  **kwargs)
+        except Errors.RepoError:
             if retrieve_can_fail:
                 return None
             raise
         except URLGrabError, e:
             if retrieve_can_fail:
                 return None
-            raise Errors.RepoError, \
-                "Could not retrieve %s matching remote checksum from %s" % (local, self)
+            raise Errors.RepoError("Could not retrieve %s matching remote checksum from %s" % (local, self.ui_id),
+                                   repo=self)
         else:
-            self.retrieved[mdtype] = 1
             return local
 
 
@@ -1646,13 +1880,21 @@ class YumRepository(Repository, config.RepoConf):
 
     def getGroups(self):
         """gets groups and returns group file path for the repository, if there
-           is none it returns None"""
+           is none or retrieve/decompress fails, it returns None"""
         if 'group_gz' in self.repoXML.fileTypes():
-            return self._retrieveMD('group_gz', retrieve_can_fail=True)
+            fn = self._retrieveMD('group_gz', retrieve_can_fail=True)
+            if fn:
+                try:
+                    fn = misc.repo_gen_decompress(fn, 'comps.xml', cached=self.cache)
+                except IOError, e:
+                    logger.warning(e)
+                    fn = None
+            return fn
         return self._retrieveMD('group', retrieve_can_fail=True)
 
-    def setCallback(self, callback):
+    def setCallback(self, callback, multi_callback=None):
         self.callback = callback
+        self.multi_callback = multi_callback
         self._callbacks_changed = True
 
     def setFailureObj(self, failure_obj):
@@ -1681,7 +1923,7 @@ class YumRepository(Repository, config.RepoConf):
                 print "Could not read mirrorlist %s, error was \n%s" %(url, e)
                 content = []
             for line in content:
-                if re.match('\s*(#|$)', line):
+                if not re.match('\w+://\S+\s*$', line):
                     continue
                 mirror = line.rstrip() # no more trailing \n's
                 mirror = mirror.replace('$ARCH', '$BASEARCH')
@@ -1701,7 +1943,8 @@ class YumRepository(Repository, config.RepoConf):
         fo = None
 
         cacheok = False
-        if self.withinCacheAge(self.mirrorlist_file, self.mirrorlist_expire):
+        if self.withinCacheAge(self.mirrorlist_file, self.mirrorlist_expire,
+                               expire_req_filter=False):
             cacheok = True
             fo = open(self.mirrorlist_file, 'r')
             url = 'file://' + self.mirrorlist_file # just to keep self._readMirrorList(fo,url) happy
@@ -1713,7 +1956,7 @@ class YumRepository(Repository, config.RepoConf):
             ugopts = self._default_grabopts()
             try:
                 fo = urlgrabber.grabber.urlopen(url, **ugopts)
-            except urlgrabber.grabber.URLGrabError, e:
+            except URLGrabError, e:
                 print "Could not retrieve mirrorlist %s error was\n%s: %s" % (url, e.args[0], misc.to_unicode(e.args[1]))
                 fo = None
 
@@ -1740,7 +1983,11 @@ class YumRepository(Repository, config.RepoConf):
         if os.path.exists(destfn):
             if os.stat(fn)[stat.ST_CTIME] <= os.stat(destfn)[stat.ST_CTIME]:
                 return False
-        shutil.copy2(fn, destfn)
+        try:
+            # IOError is the main culprit, with mode=600. But ignore everything.
+            shutil.copy2(fn, destfn)
+        except:
+            return False
         return True
 
     def _preload_file_from_system_cache(self, filename, subdir='',
@@ -1877,7 +2124,7 @@ def getMirrorList(mirrorlist, pdict = None):
 
     try:
         fo = urlresolver.urlopen(url, proxies=pdict)
-    except urlgrabber.grabber.URLGrabError, e:
+    except URLGrabError, e:
         print "Could not retrieve mirrorlist %s error was\n%s: %s" % (url, e.args[0], misc.to_unicode(e.args[1]))
         fo = None
 
